//+------------------------------------------------------------------+
//|                                                    ma_expert.mq4 |
//|                                        code by Newdigital        |
//|                                        http://www.forex-tsd.com  |
//|                                           using Gordago software |
//|                                          http://www.gordago.com  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "newdigital"
#property link      "http://www.forex-tsd.com"

#define MAGIC 392422

extern string PARAMETERS_EXPERT = "PARAMETERS EXPERT";
extern color clOpenBuy = Blue;
extern color clCloseBuy = Aqua;
extern color clOpenSell = Red;
extern color clCloseSell = Violet;
extern string Name_Expert = "ma_expert";
extern bool UseSound = True;
extern string NameFileSound = "alert.wav";

extern string PARAMETERS_TRADE = "PARAMETERS TRADE";
extern double Lots = 0.10;
extern int Slippage = 4;
extern bool UseHourTrade = True;
extern int FromHourTrade = 8;
extern int ToHourTrade = 18;

extern string PARAMETERS_INDICATOR_ONE  = "Moving Average";
extern int MAsmallMode =  1; //0=sma, 1=ema, 2=smma, 3=lwma
extern double MAsmall = 6;
extern double MAbig = 12;
extern int MAbigMode =  1; //0=sma, 1=ema, 2=smma, 3=lwma


void deinit() {
   Comment("");
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
   if (UseHourTrade){
      if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)) {
         Comment("Time for trade has not come else!");
         return(0);
      } else Comment("");
   }else Comment("");
   if(Bars<100){
      Print("bars less than 100");
      return(0);
   }

   double diMA0=iMA(NULL,0,MAsmall,0,MAsmallMode,PRICE_CLOSE,1);
   double diMA1=iMA(NULL,0,MAbig,0,MAbigMode,PRICE_CLOSE,1);
   double diMA2=iMA(NULL,0,MAsmall,0,MAsmallMode,PRICE_CLOSE,0);
   double diMA3=iMA(NULL,0,MAbig,0,MAbigMode,PRICE_CLOSE,0);
   double diMA4=iMA(NULL,0,MAsmall,0,MAsmallMode,PRICE_CLOSE,1);
   double diMA5=iMA(NULL,0,MAbig,0,MAbigMode,PRICE_CLOSE,1);
   double diMA6=iMA(NULL,0,MAsmall,0,MAsmallMode,PRICE_CLOSE,0);
   double diMA7=iMA(NULL,0,MAbig,0,MAbigMode,PRICE_CLOSE,0);
   double diMA8=iMA(NULL,0,MAsmall,0,MAsmallMode,PRICE_CLOSE,0);
   double diMA9=iMA(NULL,0,MAbig,0,MAbigMode,PRICE_CLOSE,0);
   double diMA10=iMA(NULL,0,MAsmall,0,MAsmallMode,PRICE_CLOSE,0);
   double diMA11=iMA(NULL,0,MAbig,0,MAbigMode,PRICE_CLOSE,0);

   if(AccountFreeMargin()<(1000*Lots)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);
   }
   if (!ExistPositions()){

      if ((diMA0<diMA1 && diMA2>diMA3)){
         OpenBuy();
         return(0);
      }

      if ((diMA4>diMA5 && diMA6<diMA7)){
         OpenSell();
         return(0);
      }
   }
   if (ExistPositions()){
      if(OrderType()==OP_BUY){

         if ((diMA8<=diMA9)){
            CloseBuy();
            return(0);
         }
      }
      if(OrderType()==OP_SELL){

         if ((diMA10>=diMA11)){
            CloseSell();
            return(0);
         }
      }
   }
   return (0);
}

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
				return(True);
			}
		} 
	} 
	return(false);
}
void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   if (fm && UseSound) PlaySound(NameFileSound); 
} 

void CloseBuy() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy); 
   if (fc && UseSound) PlaySound(NameFileSound); 
} 
void CloseSell() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell); 
   if (fc && UseSound) PlaySound(NameFileSound); 
} 
void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = 0; 
   ldTake = 0; 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,Ask,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenBuy); 
   if (UseSound) PlaySound(NameFileSound); 
} 
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 

   ldLot = GetSizeLot(); 
   ldStop = 0; 
   ldTake = 0; 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,ldLot,Bid,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenSell); 
   if (UseSound) PlaySound(NameFileSound); 
} 
string GetCommentForOrder() { 	return(Name_Expert); } 
double GetSizeLot() { 	return(Lots); } 

